module System
  # _[W\鎞(t[P)
  DRAW_DAMAGE_TIME = 30
end

#--------------------------------------------------------------------------
#  _[W\NX
#    U󂯂ƂɉʏɃ_[W̐܂
#    NXɑgݍŎg\
#--------------------------------------------------------------------------
class Sprite_Damage < Sprite
  
  #--------------------------------------------------------------------------
  #  
  #--------------------------------------------------------------------------
  def initialize(viewport, character)
    super(viewport)
    @timer = Game_Timer.new()
    @character  = character
    self.bitmap = Cache.empty_bitmap()
    self.clear()
  end
  
  #--------------------------------------------------------------------------
  #  NA
  #--------------------------------------------------------------------------
  def clear
    @adjustment = 0
    @scroll = System::Math::Vector2.Zero()
    @flag   = false
    
    self.x = 0
    self.y = 0
    self.z = @character.screen_z
    self.viewport.z = @character.screen_z
    
    color = System::Color.FloralWhite
    self.bitmap.font.color = Color.new(color.r, color.g, color.b, color.a)
    self.bitmap.font.size = 25
  end
  
  #--------------------------------------------------------------------------
  #  XV
  #--------------------------------------------------------------------------
  def update()
    super()
    @timer.update()
    self.update_position()
    self.BitmapClear()
  end
  
  #--------------------------------------------------------------------------
  #  n
  #--------------------------------------------------------------------------
  def dispose
    self.bitmap.dispose()
    super()
  end
  
  #--------------------------------------------------------------------------
  #  ʒu̍XV
  #--------------------------------------------------------------------------
  def update_position
    return unless @timer.working?
    @scroll.y += 1
    self.x = @character.screen_x - @adjustment
    self.y = @character.screen_y - 16 - @scroll.y
  end
  
  #--------------------------------------------------------------------------
  #  n
  #--------------------------------------------------------------------------
  def BitmapClear
    return if @timer.working? || !@flag
    self.bitmap.clear()
    self.clear()
  end
  
  #--------------------------------------------------------------------------
  #  `揈
  #--------------------------------------------------------------------------
  def Draw(text)
    return if Game_Timer.Manager(@timer, System::DRAW_DAMAGE_TIME)
    
    # EBhEW
    @adjustment = AdjustmentPosition(text.to_s.length)
    dx = @character.screen_x - @adjustment
    dy = @character.screen_y - 16
    
    self.x = dx
    self.y = dy
    fontSize = self.bitmap.font.size
    self.bitmap.draw_text(0, 0, fontSize * 5, fontSize, text)
    
    # `tO𗧂Ă
    @flag = true
  end
  
  #--------------------------------------------------------------------------
  #  eLXg̒ʒu
  #    5̃_[WoƂāA^񒆂EɕԂ̂Ȃ̂
  #--------------------------------------------------------------------------
  def AdjustmentPosition(length)
    # 1̎ɕ̂͂̂ňĂ
    length -= 1
    
    # ^񒆂\AȂpȂ̂
    fontSize = self.bitmap.font.size / 4
    
    # ŏ班Ăۂ̂Œ
    adjust = fontSize / 2
    
    # Ȃ񂩂Ă邯ǌ덷͈͂Ȃ̂ł悵Ƃ
    return (fontSize * length) + adjust
  end
  
  def SetColor(color)
    self.bitmap.font.color = Color.new(color.r, color.g, color.b, color.a)
  end
  
  def SetSize(size)
    self.bitmap.font.size = size
  end
end